/*
 *  TOPPERS/JSP Kernel
 *      Toyohashi Open Platform for Embedded Real-Time Systems/
 *      Just Standard Profile Kernel
 * 
 *  Copyright (C) 2000-2004 by Embedded and Real-Time Systems Laboratory
 *                              Toyohashi Univ. of Technology, JAPAN
 *  Copyright (C) 2001-2004 by Dep. of Computer Science and Engineering
 *                   Tomakomai National College of Technology, JAPAN
 *
 *  嵭Ԥϡʲ (1)(4) ξ狼Free Software Foundation 
 *  ˤäƸɽƤ GNU General Public License  Version 2 ˵
 *  ҤƤ˸¤ꡤܥեȥܥեȥ
 *  ѤΤޤࡥʲƱˤѡʣѡۡʰʲ
 *  ѤȸƤ֡ˤ뤳Ȥ̵ǵ롥
 *  (1) ܥեȥ򥽡ɤηѤˤϡ嵭
 *      ɽѾ浪Ӳ̵ݾڵ꤬Τޤޤηǥ
 *      ˴ޤޤƤ뤳ȡ
 *  (2) ܥեȥ򡤥饤֥ʤɡ¾Υեȥȯ˻
 *      ѤǤǺۤˤϡۤȼɥȡ
 *      ԥޥ˥奢ʤɡˤˡ嵭ɽѾ浪Ӳ
 *      ̵ݾڵǺܤ뤳ȡ
 *  (3) ܥեȥ򡤵Ȥ߹ʤɡ¾Υեȥȯ˻
 *      ѤǤʤǺۤˤϡΤ줫ξ
 *      ȡ
 *    (a) ۤȼɥȡѼԥޥ˥奢ʤɡˤˡ嵭
 *        ɽѾ浪Ӳ̵ݾڵǺܤ뤳ȡ
 *    (b) ۤη֤̤ˡˤäơTOPPERSץȤ
 *        𤹤뤳ȡ
 *  (4) ܥեȥѤˤľŪޤϴŪ뤤ʤ»
 *      ⡤嵭ԤTOPPERSץȤդ뤳ȡ
 *
 *  ܥեȥϡ̵ݾڤ󶡤ƤΤǤ롥嵭Ԥ
 *  TOPPERSץȤϡܥեȥ˴ؤơŬѲǽ
 *  ޤơʤݾڤԤʤޤܥեȥѤˤľ
 *  ŪޤϴŪʤ»˴ؤƤ⡤Ǥʤ
 * 
 *  @(#) $Id: ppp_ipcp.c,v 1.2.1.3 2005/07/25 08:04:12 abe Exp abe $
 */

/*
 * ipcp.c - PPP IP Control Protocol.
 *
 * Copyright (c) 1989 Carnegie Mellon University.
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms are permitted
 * provided that the above copyright notice and this paragraph are
 * duplicated in all such forms and that any documentation,
 * advertising materials, and other materials related to such
 * distribution and use acknowledge that the software was developed
 * by Carnegie Mellon University.  The name of the
 * University may not be used to endorse or promote products derived
 * from this software without specific prior written permission.
 * THIS SOFTWARE IS PROVIDED ``AS IS'' AND WITHOUT ANY EXPRESS OR
 * IMPLIED WARRANTIES, INCLUDING, WITHOUT LIMITATION, THE IMPLIED
 * WARRANTIES OF MERCHANTIBILITY AND FITNESS FOR A PARTICULAR PURPOSE.
 */

#if 0
#ifndef lint
static char rcsid = "$FreeBSD: src/usr.sbin/pppd/ipcp.c,v 1.11.2.1 1999/08/29 15:47:00 peter Exp $";
#endif
#endif

/*
 *	PPP IP Control Protocol (IPCP) Module
 *
 *	    Written by Toshiharu OHNO (tony-o@iij.ad.jp)
 *
 *   Copyright (C) 1993, Internet Initiative Japan, Inc. All rights reserverd.
 *
 * Redistribution and use in source and binary forms are permitted
 * provided that the above copyright notice and this paragraph are
 * duplicated in all such forms and that any documentation,
 * advertising materials, and other materials related to such
 * distribution and use acknowledge that the software was developed
 * by the Internet Initiative Japan, Inc.  The name of the
 * IIJ may not be used to endorse or promote products derived
 * from this software without specific prior written permission.
 * THIS SOFTWARE IS PROVIDED ``AS IS'' AND WITHOUT ANY EXPRESS OR
 * IMPLIED WARRANTIES, INCLUDING, WITHOUT LIMITATION, THE IMPLIED
 * WARRANTIES OF MERCHANTIBILITY AND FITNESS FOR A PARTICULAR PURPOSE.
 *
 * $FreeBSD: src/usr.sbin/ppp/ipcp.c,v 1.90.2.4 2000/08/19 09:30:03 brian Exp $
 *
 *	TODO:
 *		o Support IPADDRS properly
 *		o Validate the length in IpcpDecodeConfig
 */

#include <string.h>

#include <s_services.h>
#include <t_services.h>
#include "kernel_id.h"

#include <tinet_defs.h>
#include <tinet_config.h>

#include <net/if.h>
#include <net/if_ppp.h>
#include <net/net.h>
#include <net/net_buf.h>
#include <net/net_count.h>
#include <net/ppp.h>
#include <net/ppp_var.h>
#include <net/ppp_fsm.h>
#include <net/ppp_lcp.h>
#include <net/ppp_ipcp.h>
#include <net/ppp_modem.h>

#include <netinet/in.h>
#include <netinet/in_var.h>
#include <netinet/ip.h>
#include <netinet/tcp.h>
#include <netinet/tcp_timer.h>
#include <netinet/tcp_var.h>
#include <netinet/udp_var.h>

#include <net/if_var.h>

/*
 *  ؿ
 */

static void ipcp_init (void);
static void ipcp_input (T_NET_BUF *input);
static void ipcp_protrej (void);
static void ipcp_lowerup (void);
static void ipcp_lowerdown (void);
static void ipcp_open (void);
static void ipcp_close (void);

/*
 * FSM ƽФ륳Хå
 */

static void ipcp_resetci(T_PPP_FSM *fsm);	/* ꥻåȤ롣	*/
static INT  ipcp_cilen	(T_PPP_FSM *fsm);	/* Ĺ֤		*/
static void ipcp_addci	(T_PPP_FSM *fsm, T_NET_BUF *output);
						/* ɲä롣		*/
static BOOL ipcp_ackci	(T_PPP_FSM *fsm, T_NET_BUF *input);
						/* ACK Ȥν	*/
static BOOL ipcp_nakci	(T_PPP_FSM *fsm, T_NET_BUF *input);
						/* NAK Ȥν	*/
static BOOL ipcp_rejci	(T_PPP_FSM *fsm, T_NET_BUF *input);
						/* REJ Ȥν	*/
static INT  ipcp_reqci	(T_PPP_FSM *fsm, T_NET_BUF *input, T_NET_BUF *output);
						/* ιǧ롣	*/
static void ipcp_up	(T_PPP_FSM *fsm);	/* ³Ω롣		*/
static void ipcp_down	(T_PPP_FSM *fsm);	/* ³롣		*/
static void ipcp_finished(T_PPP_FSM *fsm);	/* ؤλ롣		*/

/*
 *  ѿ
 */

static T_IFNET ipcp_local_def_cfg = {		/* ε		*/
	NULL,
	{
		IPV4_ADDR_LOCAL,		/* IP ɥ쥹			*/
		0,				/* ֥ͥåȥޥ		*/
		},
	};

static T_IFNET ipcp_remote_def_cfg = {		/* ιε	*/
	NULL,
	{
		IPV4_ADDR_REMOTE,		/* IP ɥ쥹			*/
		0,				/* ֥ͥåȥޥ		*/
		}
	};

static T_IFNET ipcp_local_neg_cfg;		/* ͥμ		*/

static T_IFNET ipcp_remote_neg_cfg;		/* ͥι		*/

/*
 *  ѿ
 */

T_PPP_FSM_CALLBACKS ipcp_callbacks = {
	ipcp_resetci,			/* ꥻåȤ롣	*/
	ipcp_cilen,			/* Ĺ֤		*/
	ipcp_addci,			/* ɲä롣		*/
	ipcp_ackci,			/* ACK Ȥν	*/
	ipcp_nakci,			/* NAK Ȥν	*/
	ipcp_rejci,			/* REJ Ȥν	*/
	ipcp_reqci,			/* ιǧ롣	*/
	ipcp_up,			/* ³Ω롣		*/
	ipcp_down,			/* ³롣		*/
	NULL,				/* ؤ򳫻Ϥ롣		*/
	ipcp_finished,			/* ؤλ롣		*/
	NULL,				/* 롣			*/
	NULL,				/*  CP Ȥν	*/
	};

T_PPP_FSM ipcp_fsm = {
	&ipcp_callbacks,		/* Хåؿ		*/
	PPP_IPCP,			/* ץȥ			*/
	};

T_PPP_PROTENT ipcp_protent = {
	PPP_IPCP,
	ipcp_init,			/* 			*/
	ipcp_input,			/* 				*/
	ipcp_protrej,			/* Proto-REJ 		*/
	ipcp_lowerup,			/* ؤư		*/
	ipcp_lowerdown,			/* ؤߤ		*/
	ipcp_open,			/* ץ󤹤			*/
	ipcp_close,			/* 			*/
	ip_input,			/* ǡϡIP 		*/
	};

T_IFNET ipcp_local_ack_cfg;		/* ˵Ĥ줿μ	*/
T_IFNET ipcp_remote_ack_cfg;		/* ˵Ĥ	*/

/*
 *  ppp_get_ifnet -- ͥåȥ󥿥ե¤Τ֤
 */

T_IFNET *
ppp_get_ifnet (void)
{
	return &ipcp_local_ack_cfg;
	}

/*
 *  wait_ipcp -- IP ³λޤԤġ
 *
 *	: ³˼Ԥ E_OBJ ֤
 */

ER
wait_ipcp (void)
{
#ifdef PPP_CFG_MODEM
	ER error;
#endif	/* of #ifdef PPP_CFG_MODEM */

	if (ipcp_fsm.state <= PPP_FSM_STOPPED) {

#ifdef PPP_CFG_MODEM

		/* ǥ³λޤԤġ*/
		if ((error = wait_modem()) != E_OK)
			return error;

#else	/* of #ifdef PPP_CFG_MODEM */

		/*
		 * ưץ󤷡꤫³Ԥʤ LCP ٥
		 * ǽưץ֤ǡƥץ󤹤롣
		 */
		lcp_close();
		lcp_open(PPP_OPEN_ACTIVE);

#endif	/* of #ifdef PPP_CFG_MODEM */

		}

	if (ipcp_fsm.state != PPP_FSM_OPENED) {
		/* IP ³λޤԤġ*/
		wai_sem(SEM_IPCP_READY);
		if (ipcp_fsm.state != PPP_FSM_OPENED)
			return E_OBJ;
		}

	return E_OK;
	}

/*
 *  ipcp_init -- IPCP ⥸塼ν
 */

static void
ipcp_init (void)
{
	fsm_init(&ipcp_fsm);
	}

/*
 *  ipcp_input -- IPCP 
 */

static void
ipcp_input (T_NET_BUF *input)
{
	NET_COUNT_PPP_IPCP(net_count_ppp_ipcp_in_octets,  input->len);
	NET_COUNT_PPP_IPCP(net_count_ppp_ipcp_in_packets, 1);
	fsm_input(&ipcp_fsm, input);
	}

/*
 *  ipcp_resetci -- IPCPιꥻåȤ롣
 */

static void
ipcp_resetci (T_PPP_FSM *fsm)
{
	/* ν */
	ipcp_local_neg_cfg = ipcp_local_def_cfg;
	memset((void*)&ipcp_local_ack_cfg, 0, sizeof(T_IFNET));

	/* ιν */
	ipcp_remote_neg_cfg = ipcp_remote_def_cfg;
	memset((void*)&ipcp_remote_ack_cfg, 0, sizeof(T_IFNET));
	}

/*
 *  ipcp_cilen -- Ĺ֤
 */

static INT
ipcp_cilen (T_PPP_FSM *fsm)
{
	INT cilen = 0;

	cilen += sizeof(T_PPP_CI_HDR) + sizeof(UW);	/* IP ɥ쥹 */

	return cilen;
	}

/*
 *  ipcp_addci -- IPCPιɲä롣
 */

static void
ipcp_addci (T_PPP_FSM *fsm, T_NET_BUF *output)
{
	UB *buf;

	buf = output->buf + sizeof(T_PPP_HDR) + sizeof(T_PPP_CP_HDR);

	/* IP ɥ쥹ץɲä롣 */
	*buf ++ = IPCP_CIT_ADDR;
	*buf ++ = sizeof(T_PPP_CI_HDR) + sizeof(UW);
	ahtonl(buf, ipcp_local_neg_cfg.in_ifaddr.addr);
	buf += sizeof(UW);
	}

/*
 *  ipcp_ackci -- ACK Ȥν
 *
 *	:	TURE  ACK 
 *		FALSE ACK ϰ۾
 */

static BOOL
ipcp_ackci (T_PPP_FSM *fsm, T_NET_BUF *input)
{
	UB *buf;
	UH len;

	buf = input->buf +  sizeof(T_PPP_HDR) + sizeof(T_PPP_CP_HDR);
	len = input->len - (sizeof(T_PPP_HDR) + sizeof(T_PPP_CP_HDR));

	/*
	 *  ˴˰פʤФʤʤ
	 *  äơipcp_addci Ǻ˲Ϥ롣
	 */

	/* ADDR ץϤ롣 */
	if (len < sizeof(T_PPP_CI_HDR) + sizeof(UW)	||
	    *buf ++ != IPCP_CIT_ADDR			||
	    *buf ++ != sizeof(T_PPP_CI_HDR) + sizeof(UW)||
	    nahcmpl(buf, ipcp_local_neg_cfg.in_ifaddr.addr))
		return FALSE;
	buf += sizeof(UW);
	len -= sizeof(T_PPP_CI_HDR) + sizeof(UW);

	return TRUE;
	}

/*
 *  ipcp_nakci -- NAK Ȥν
 *
 *	:	1  NAK 
 *		0  NAK ϰ۾
 */

static INT
ipcp_nakci (T_PPP_FSM *fsm, T_NET_BUF *input)
{
	T_IFNET	new_cfg;
	UW	cilong;
	UB	*buf;
	UH	len;
	UB	cilen;

	buf = input->buf +  sizeof(T_PPP_HDR) + sizeof(T_PPP_CP_HDR);
	len = input->len - (sizeof(T_PPP_HDR) + sizeof(T_PPP_CP_HDR));

	new_cfg = ipcp_local_neg_cfg;

	/* ADDR ץϤ롣 */
	if (len >= sizeof(T_PPP_CI_HDR) + sizeof(UW)		&&
	    * buf      == IPCP_CIT_ADDR				&&
	    *(buf + 1) == sizeof(T_PPP_CI_HDR) + sizeof(UW)) {
	    	ntoahl(cilong, buf + 2);
		buf += sizeof(T_PPP_CI_HDR) + sizeof(UW);
		len -= sizeof(T_PPP_CI_HDR) + sizeof(UW);
		new_cfg.in_ifaddr.addr = cilong;
		}

	/* ̵뤹롣*/
	while (len > sizeof(T_PPP_CI_HDR)) {
		cilen = *(buf + 1);
		if (len < cilen)
			return 0;
		buf += cilen;
		len -= cilen;
		}

	/* Ĺ 0 ǤʤХ顼 */
	if (len != 0)
		return 0;

	/* ץꤹ롣*/
	if (fsm->state != PPP_FSM_OPENED)
		ipcp_local_neg_cfg = new_cfg;
               		
	return 1;
	}

/*
 *  ipcp_rejci -- REJ Ȥν
 *
 *	:	1  REJ 
 *		0  REJ ϰ۾
 */

static INT
ipcp_rejci (T_PPP_FSM *fsm, T_NET_BUF *input)
{
	T_IFNET	new_cfg;
	UB	*buf;
	UH	len;

	buf = input->buf +  sizeof(T_PPP_HDR) + sizeof(T_PPP_CP_HDR);
	len = input->len - (sizeof(T_PPP_HDR) + sizeof(T_PPP_CP_HDR));

	new_cfg = ipcp_local_neg_cfg;

	/* ADDR ץϤ롣 */
	if (len >= sizeof(T_PPP_CI_HDR) + sizeof(UW)		&&
	    * buf      == IPCP_CIT_ADDR				&&
	    *(buf + 1) == sizeof(T_PPP_CI_HDR) + sizeof(UW)) {
		buf += sizeof(T_PPP_CI_HDR) + sizeof(UW);
		len -= sizeof(T_PPP_CI_HDR) + sizeof(UW);
		new_cfg.in_ifaddr.addr = 0;
		}

	/* Ĺ 0 ǤʤХ顼 */
	if (len != 0)
		return 0;

	/* ץꤹ롣*/
	if (fsm->state != PPP_FSM_OPENED)
		ipcp_local_neg_cfg = new_cfg;

	return 1;
	}

/*
 *  ipcp_reqci -- ιϤ롣
 */

static INT
ipcp_reqci (T_PPP_FSM *fsm, T_NET_BUF *input, T_NET_BUF *output)
{
	UB *np, *rp, *ap, *cp;
	UW addr;
	UH code, final, len, cilen;
	UB type = 0;

	rp = ap = input->buf +  sizeof(T_PPP_HDR) + sizeof(T_PPP_CP_HDR);
				/* rp: REJap: ACK  CI Υݥ	*/
				/* ݤϡ buf ˾񤭤롣	*/
	len   = input->len - (sizeof(T_PPP_HDR) + sizeof(T_PPP_CP_HDR));
	np    = output->buf + sizeof(T_PPP_HDR) + sizeof(T_PPP_CP_HDR);
	final = PPP_CONFACK;	/* ǽŪ륳 */
	while (len > 0) {
		code = PPP_CONFACK;
		cp   = ap;	/* cp: ߽ CI	*/

		if (len < sizeof(T_PPP_CI_HDR)) {

			/* Ĥ꤬ CI إåû */
			syslog(LOG_NOTICE, "[PPP/IPCP] bad CI len: %d.", len);
			cilen = len;	/* ǡĹ۾ξν	*/
			len  = 0;	/* 롼פȴ롣		*/
			code  = PPP_CONFREJ;
			goto endswitch;
			}

		type  = *ap ++;	/* CI η		*/
		cilen = *ap ++;	/* CI Ĺ		*/
		if (len < cilen) {

			/* Ĥ꤬ CI Ĺû */
			syslog(LOG_NOTICE, "[PPP/IPCP] bad CI len: %d.", cilen);
			cilen = len;	/* ǡĹ۾ξν	*/
			len  = 0;	/* 롼פȴ롣		*/
			code  = PPP_CONFREJ;
			goto endswitch;
			}
		len -= sizeof(T_PPP_CI_HDR);

		/* CI ηˤʬ롣*/
		switch (type) {

		case IPCP_CIT_ADDR:	/* IP ɥ쥹 */

		 	/* CI Ĺإå + 4 ƥåȤǤʤХ顼 */
		 	if (cilen != sizeof(T_PPP_CI_HDR) + sizeof(UW))
				code = PPP_CONFREJ;
			else {
				ntoahl(addr, ap);
				if (addr != ipcp_remote_neg_cfg.in_ifaddr.addr &&
				    (addr == 0 || ipcp_remote_neg_cfg.in_ifaddr.addr != 0)) {
					*np ++ = IPCP_CIT_ADDR;
					*np ++ = sizeof(T_PPP_CI_HDR) + sizeof(UW);
					ahtonl(np, ipcp_remote_neg_cfg.in_ifaddr.addr);
					np  += sizeof(UW);
					code = PPP_CONFNAK;
					}
				else if (addr == 0 || ipcp_remote_neg_cfg.in_ifaddr.addr == 0)
					code = PPP_CONFREJ;
				else
					ipcp_remote_neg_cfg.in_ifaddr.addr = addr;
				}
			break;

		default:
			syslog(LOG_INFO, "[PPP/IPCP] unexp opt: %d.", type);
			code = PPP_CONFREJ;
			break;
			}
endswitch:

		if (code == PPP_CONFNAK) {
			/* CI η Magic Number ξơNAK β	*/
			/*  MAX_PPP_FAILURES  Ķݤ롣	*/
			if (fsm->failures >= MAX_PPP_FAILURES)
				code = PPP_CONFREJ;
			else if (final != PPP_CONFREJ)
				final = PPP_CONFNAK;
			}

		/*  CI ݤ */
		if (code == PPP_CONFREJ) {
			if (rp < cp)		/* ˵ͤ롣*/
				memcpy(rp, cp, cilen);
			rp += cilen;
			final = PPP_CONFREJ;
			}

		ap   += cilen - sizeof(T_PPP_CI_HDR);
		len  -= cilen - sizeof(T_PPP_CI_HDR);
		}

	/* ǽŪĹĴ롣*/
	switch (final) {
	case PPP_CONFNAK:
		output->len = np - output->buf;
		memcpy(output->buf, input->buf, sizeof(T_PPP_HDR) + sizeof(T_PPP_CP_HDR));
		break;
	case PPP_CONFREJ:
		memcpy(output->buf, input->buf, output->len = rp - input->buf);
		break;
	case PPP_CONFACK:
		memcpy(output->buf, input->buf, input->len);
		break;
		}

	return final;
	}

/*
 *  ipcp_up -- ³Ω롣
 */

static void
ipcp_up (T_PPP_FSM *fsm)
{
	static UB local_addr [sizeof("123.123.123.123")];
	static UB remote_addr[sizeof("123.123.123.123")];

	/* ν */
	ipcp_local_ack_cfg = ipcp_local_neg_cfg;

	/*
	 *  ֥ͥåȥޥ
	 *  롦֥ɥ㥹 IP ɥ쥹ꤹ롣
	 */
	ipcp_local_ack_cfg.in_ifaddr.mask = MAKE_IPV4_LOCAL_MASK(ipcp_local_neg_cfg.in_ifaddr.addr);

	/* ιν */
	ipcp_remote_ack_cfg = ipcp_remote_neg_cfg;

	/*
	 *  ֥ͥåȥޥ
	 *  롦֥ɥ㥹 IP ɥ쥹ꤹ롣
	 */
	ipcp_remote_ack_cfg.in_ifaddr.mask = MAKE_IPV4_LOCAL_MASK(ipcp_remote_neg_cfg.in_ifaddr.addr);

	sig_sem(SEM_IPCP_READY);

	ip2str(local_addr,  &ipcp_local_neg_cfg.in_ifaddr.addr);
	ip2str(remote_addr, &ipcp_remote_neg_cfg.in_ifaddr.addr);
	syslog(LOG_NOTICE, "[PPP/IPCP] up, Local IP Addr: %s, Remote IP Addr: %s.",
	                   local_addr, remote_addr);
	}

/*
 *  ipcp_down -- ³롣
 */

static void
ipcp_down (T_PPP_FSM *fsm)
{
	sig_sem(SEM_IPCP_READY);
	syslog(LOG_NOTICE, "[PPP/IPCP] down.");
	}

/*
 *  ipcp_finished -- ؤλ롣
 */

static void
ipcp_finished (T_PPP_FSM *fsm)
{
	}

/*
 *  ipcp_protrej -- Proto-REJ Ȥν
 */

static void
ipcp_protrej (void)
{
	fsm_lowerdown(&ipcp_fsm);
	}

/*
 *  ipcp_lowerup -- IPCP ؤư롣
 */

static void
ipcp_lowerup (void)
{
	fsm_lowerup(&ipcp_fsm);
	}

/*
 *  ipcp_lowerdown -- IPCP ؤߤ롣
 */

static void
ipcp_lowerdown (void)
{
	fsm_lowerdown(&ipcp_fsm);
	}

/*
 *  ipcp_open -- IPCP Υץ
 */

static void
ipcp_open (void)
{
	fsm_open(&ipcp_fsm);
	}

/*
 *  ipcp_close -- IPCP Υ
 */

static void
ipcp_close (void)
{
	fsm_close(&ipcp_fsm);
	}
