/*
 *  TOPPERS/JSP Kernel
 *      Toyohashi Open Platform for Embedded Real-Time Systems/
 *      Just Standard Profile Kernel
 * 
 *  Copyright (C) 2000-2004 by Embedded and Real-Time Systems Laboratory
 *                              Toyohashi Univ. of Technology, JAPAN
 *  Copyright (C) 2001-2004 by Dep. of Computer Science and Engineering
 *                   Tomakomai National College of Technology, JAPAN
 *
 *  嵭Ԥϡʲ (1)(4) ξ狼Free Software Foundation 
 *  ˤäƸɽƤ GNU General Public License  Version 2 ˵
 *  ҤƤ˸¤ꡤܥեȥܥեȥ
 *  ѤΤޤࡥʲƱˤѡʣѡۡʰʲ
 *  ѤȸƤ֡ˤ뤳Ȥ̵ǵ롥
 *  (1) ܥեȥ򥽡ɤηѤˤϡ嵭
 *      ɽѾ浪Ӳ̵ݾڵ꤬Τޤޤηǥ
 *      ˴ޤޤƤ뤳ȡ
 *  (2) ܥեȥ򡤥饤֥ʤɡ¾Υեȥȯ˻
 *      ѤǤǺۤˤϡۤȼɥȡ
 *      ԥޥ˥奢ʤɡˤˡ嵭ɽѾ浪Ӳ
 *      ̵ݾڵǺܤ뤳ȡ
 *  (3) ܥեȥ򡤵Ȥ߹ʤɡ¾Υեȥȯ˻
 *      ѤǤʤǺۤˤϡΤ줫ξ
 *      ȡ
 *    (a) ۤȼɥȡѼԥޥ˥奢ʤɡˤˡ嵭
 *        ɽѾ浪Ӳ̵ݾڵǺܤ뤳ȡ
 *    (b) ۤη֤̤ˡˤäơTOPPERSץȤ
 *        𤹤뤳ȡ
 *  (4) ܥեȥѤˤľŪޤϴŪ뤤ʤ»
 *      ⡤嵭ԤTOPPERSץȤդ뤳ȡ
 *
 *  ܥեȥϡ̵ݾڤ󶡤ƤΤǤ롥嵭Ԥ
 *  TOPPERSץȤϡܥեȥ˴ؤơŬѲǽ
 *  ޤơʤݾڤԤʤޤܥեȥѤˤľ
 *  ŪޤϴŪʤ»˴ؤƤ⡤Ǥʤ
 * 
 *  @(#) $Id: tcp_echo_cli.c,v 1.2.1.3 2005/07/25 08:05:12 abe Exp abe $
 */

/* 
 *  TCP ECHO 饤
 *
 *    ʬΥ
 *    Υ֥å󥰥
 *    ʥԡ API
 *    IPv4
 *    IPv6
 */

#include <t_services.h>
#include "kernel_id.h"
#include "tinet_id.h"

#include <stdlib.h>

#include <netinet/in.h>
#include <netinet/in_itron.h>

#include <netapp/netapp.h>
#include <netapp/netapp_var.h>
#include <netapp/echo.h>

/*
 *  ɽ
 */

/*#define SHOW_RCV_RANGE*/

/*
 *  Хåե
 */

#define NUM_ECHO		20
#define NUM_REP_PAT		40
#define PAT_BEGIN		' '
#define PAT_END			'~'
#define SND_BUF_SIZE		((PAT_END - PAT_BEGIN + 1) * NUM_REP_PAT)
#define RCV_BUF_SIZE		(SND_BUF_SIZE*15/10)

/*
 *  ѿ
 */

BOOL tcp_echo_cli_valid;

/*
 *  ѿ
 */

static int		scount;
static int		rcount;

#ifdef USE_TCP_NON_BLOCKING

static T_IPEP		nblk_src = {
				IP_ADDRANY,
				TCP_PORTANY,
				};
static T_IPEP		nblk_dst;
static ER_UINT		nblk_error;

/*
 *  Υ֥å󥰥ΥХåؿ
 */

ER
callback_nblk_tcp_echo_cli (ID cepid, FN fncd, VP p_parblk)
{
	static UB addr[sizeof("0123:4567:89ab:cdef:0123:4567:89ab:cdef")];

	ER	error = E_OK;

	nblk_error = (ER)p_parblk;

	switch (fncd) {

	case TFN_TCP_CON_CEP:
		IP2STR(addr, &nblk_dst.ipaddr);
		syscall(sig_sem(SEM_TCP_ECHO_CLI_NBLK_READY));
		break;

	case TFN_TCP_RCV_BUF:
		if (nblk_error < 0)
			syslog(LOG_NOTICE, "[TEC:%02d CBN] recv buf error: %s", cepid, itron_strerror(nblk_error));
		syscall(sig_sem(SEM_TCP_ECHO_CLI_NBLK_READY));
		break;

	case TFN_TCP_CLS_CEP:
		if (nblk_error < 0)
			syslog(LOG_NOTICE, "[TEC:%02d CBN] close error: %s", cepid, itron_strerror(nblk_error));
		syscall(sig_sem(SEM_TCP_ECHO_CLI_NBLK_READY));
		break;

	case TFN_TCP_RCV_DAT:
		if (nblk_error < 0)
			syslog(LOG_NOTICE, "[TEC:%02d CBN] recv dat error: %s", cepid, itron_strerror(nblk_error));
		syscall(sig_sem(SEM_TCP_ECHO_CLI_NBLK_READY));
		break;

	case TFN_TCP_ACP_CEP:
	case TFN_TCP_SND_DAT:
	case TFN_TCP_GET_BUF:
	case TFN_TCP_SND_OOB:
	default:
		error = E_PAR;
		break;
		}
	return error;
	}

/*
 *  send_tcp_echo -- ECHO/TCP Ф˥å롣
 */

static void
send_tcp_echo (ID cepid, T_IN_ADDR *ipaddr, UH portno)
{
	static UB addr[sizeof("0123:4567:89ab:cdef:0123:4567:89ab:cdef")];
	static UB smsg[SND_BUF_SIZE];

	int	pat, slen, soff, echo, rep, total;
	UB	*p;
	ER	error;
	SYSTIM	time;

	IP2STR(addr, ipaddr);

	nblk_dst.ipaddr = *ipaddr;
	nblk_dst.portno = portno;

	p = smsg;
	for (rep = NUM_REP_PAT; rep -- > 0; )
		for (pat = PAT_BEGIN; pat <= PAT_END; pat ++)
			*p ++ = pat;

	if ((error = TCP_CON_CEP(cepid, &nblk_src, &nblk_dst, TMO_NBLK)) != E_WBLK) {
		syslog(LOG_NOTICE, "[TEC:%02d SND] connect error: %s", cepid, itron_strerror(error));
		return;
		}

	/* ³λޤԤġ*/
	syscall(wai_sem(SEM_TCP_ECHO_CLI_NBLK_READY));

	if (nblk_error != E_OK)
		syslog(LOG_NOTICE, "[TEC:%02d SND] connect error: %s", cepid, itron_strerror(nblk_error));
	else {
		get_tim(&time);
		syslog(LOG_NOTICE, "[TEC:%02d SND] connecting: %6d, to:   %s.%d",
		                   cepid, time / SYSTIM_HZ, addr, nblk_dst.portno);

		syscall(wup_tsk(TCP_ECHO_CLI_RCV_TASK));

		scount = total = 0;
		for (echo = NUM_ECHO; echo -- > 0; ) {
			soff = 0;
			while (soff < SND_BUF_SIZE) {
				if ((slen = tcp_snd_dat(cepid, smsg + soff, sizeof(smsg) - soff, TMO_FEVR)) < 0) {
					syslog(LOG_NOTICE, "[TEC:%02d SND] send error: %s",
					                   cepid, itron_strerror(slen));
					goto cls_ret;
					}
				soff  += slen;
				total += slen;
				scount ++;
#ifdef SHOW_RCV_RANGE
				syslog(LOG_NOTICE, "[TEC:%02d SND] send cnt: %2d, len: %4d, off: %4d",
				                   cepid, scount, slen, soff);
#endif	/* of #ifdef SHOW_RCV_RANGE */
				dly_tsk(500 + rand() % SYSTIM_HZ);
				}
			}

	cls_ret:
		if ((error = tcp_sht_cep(cepid)) < 0)
			syslog(LOG_NOTICE, "[TEC:%02d SND] shutdown error: %s", cepid, itron_strerror(error));

		/* λޤԤġ*/
		syscall(slp_tsk());
		}
	}

/*
 *  TCP ECHO 饤ȼ
 */

#ifdef USE_COPYSAVE_API

void
tcp_echo_cli_rcv_task (VP_INT exinf)
{
	ID	tskid;
	int	roff, total, rlen;
	UB	*rmsg, head, tail;
	ER	error;
	SYSTIM	time;

	get_tid(&tskid);
	syslog(LOG_NOTICE, "[TCP ECHO CLI (NBLK,CS) RCV:%d,%d] started.", tskid, (ID)exinf);
	while (TRUE) {
		syscall(slp_tsk());

		roff = rcount = total = 0;
		while (TRUE) {
			if ((error = tcp_rcv_buf((ID)exinf, (VP*)(VP)&rmsg, TMO_NBLK)) != E_WBLK) {
				syslog(LOG_NOTICE, "[TEC:%02d RCV] recv buf error: %s", (ID)exinf, itron_strerror(error));
				break;
				}

			/* ХåեγλޤԤġ*/
			syscall(wai_sem(SEM_TCP_ECHO_CLI_NBLK_READY));

			rlen = nblk_error;
			head = *rmsg;
			tail = *(rmsg + rlen - 1);
			if (rlen > 0) {
				roff  += rlen;
				total += rlen;
				rcount ++;
#ifdef SHOW_RCV_RANGE
				syslog(LOG_NOTICE, "[TEC:%02d RCV] "
				                   "recv cnt: %2d, len: %4d, off: %4d, data: %02x -> %02x",
				                   (ID)exinf, rcount, rlen, roff, head, tail);
#endif	/* of #ifdef SHOW_RCV_RANGE */
				}
			else
				break;

			if ((error = tcp_rel_buf((ID)exinf, rlen)) != E_OK)
				syslog(LOG_NOTICE, "[TEC:%02d RCV] rel buf error: %s", 
				                   (ID)exinf, itron_strerror(error));
			}

		if ((error = tcp_cls_cep((ID)exinf, TMO_NBLK)) != E_WBLK)
			syslog(LOG_NOTICE, "[TEC:%02d SND] close error: %s", (ID)exinf, itron_strerror(error));

		/* λޤԤġ*/
		syscall(wai_sem(SEM_TCP_ECHO_CLI_NBLK_READY));

		get_tim(&time);
		syslog(LOG_NOTICE, "[TEC:%02d RCV] finished:   %6d, snd: %4d, rcv: %4d, len: %d",
		                   (ID)exinf, time / SYSTIM_HZ, scount, rcount, total);

		syscall(wup_tsk(TCP_ECHO_CLI_SND_TASK));
		}
	}

#else	/* of #ifdef USE_COPYSAVE_API */

void
tcp_echo_cli_rcv_task (VP_INT exinf)
{
	static UB rmsg[RCV_BUF_SIZE];

	ID	tskid;
	int	roff, rlen, total;
	UB	head, tail;
	ER	error;
	SYSTIM	time;

	get_tid(&tskid);
	syslog(LOG_NOTICE, "[TCP ECHO CLI (NBLK) RCV:%d,%d] started.", tskid, (ID)exinf);
	while (TRUE) {
		syscall(slp_tsk());

		roff = rcount = total = 0;
		while (TRUE) {
			if ((error = tcp_rcv_dat((ID)exinf, rmsg, sizeof(rmsg), TMO_NBLK)) != E_WBLK) {
				syslog(LOG_NOTICE, "[TEC:%02d RCV] recv error: %s", (ID)exinf, itron_strerror(error));
				break;
				}

			/* λޤԤġ*/
			syscall(wai_sem(SEM_TCP_ECHO_CLI_NBLK_READY));

			rlen = nblk_error;
			head = *rmsg;
			tail = *(rmsg + rlen - 1);
			rcount ++;
			if (rlen > 0) {
				roff  += rlen;
				total += rlen;
#ifdef SHOW_RCV_RANGE
				syslog(LOG_NOTICE, "[TEC:%02d RCV] "
				                   "recv cnt: %2d, len: %4d, off: %4d, data: %02x -> %02x",
				                   (ID)exinf, rcount, rlen, roff, head, tail);
#endif	/* of #ifdef SHOW_RCV_RANGE */
				}
			else
				break;
			}

		if ((error = tcp_cls_cep((ID)exinf, TMO_NBLK)) != E_WBLK)
			syslog(LOG_NOTICE, "[TEC:%02d SND] close error: %s", (ID)exinf, itron_strerror(error));

		/* λޤԤġ*/
		syscall(wai_sem(SEM_TCP_ECHO_CLI_NBLK_READY));

		get_tim(&time);
		syslog(LOG_NOTICE, "[TEC:%02d RCV] finished:   %6d, snd: %4d, rcv: %4d, len: %d",
		                   (ID)exinf, time / SYSTIM_HZ, scount, rcount, total);

		syscall(wup_tsk(TCP_ECHO_CLI_SND_TASK));
		}
	}

#endif	/* of #ifdef USE_COPYSAVE_API */

#else	/* of #ifdef USE_TCP_NON_BLOCKING */

/*
 *  send_tcp_echo -- ECHO/TCP Ф˥å롣
 */

static void
send_tcp_echo (ID cepid, T_IN_ADDR *ipaddr, UH portno)
{
	static UB addr[sizeof("0123:4567:89ab:cdef:0123:4567:89ab:cdef")];
	static UB smsg[SND_BUF_SIZE];
	static T_IPEP src = {
		IP_ADDRANY,
		TCP_PORTANY,
		};

	T_IPEP	dst;
	int	pat, slen, soff, echo, rep, total;
	UB	*p;
	ER	error;
	SYSTIM	time;

	dst.ipaddr = *ipaddr;
	dst.portno = portno;

	p = smsg;
	for (rep = NUM_REP_PAT; rep -- > 0; )
		for (pat = PAT_BEGIN; pat <= PAT_END; pat ++)
			*p ++ = pat;

	if ((error = TCP_CON_CEP(cepid, &src, &dst, 60 * SYSTIM_HZ)) != E_OK) {
		syslog(LOG_NOTICE, "[TEC:%02d SND] connect error: %s", cepid, itron_strerror(error));
		return;
		}

	get_tim(&time);
	IP2STR(addr, ipaddr);
	syslog(LOG_NOTICE, "[TEC:%02d SND] connecting: %6d, to:   %s.%d", cepid, time / SYSTIM_HZ, &addr, portno);

	syscall(wup_tsk(TCP_ECHO_CLI_RCV_TASK));

	scount = total = 0;
	for (echo = NUM_ECHO; echo -- > 0; ) {
		soff = 0;
		while (soff < SND_BUF_SIZE) {
			if ((slen = tcp_snd_dat(cepid, smsg + soff, sizeof(smsg) - soff, TMO_FEVR)) < 0) {
				syslog(LOG_NOTICE, "[TEC:%02d SND] send error: %s", cepid, itron_strerror(slen));
				goto cls_ret;
				}
			soff  += slen;
			total += slen;
			scount ++;
#ifdef SHOW_RCV_RANGE
			syslog(LOG_NOTICE, "[TEC:%02d SND] send count: %3d, len: %4d, offset: %4d",
			                   cepid, scount, slen, soff);
#endif	/* of #ifdef SHOW_RCV_RANGE */
			dly_tsk(500 + rand() % SYSTIM_HZ);
			}
		}

cls_ret:
	if ((error = tcp_sht_cep(cepid)) < 0)
		syslog(LOG_NOTICE, "[TEC:%02d SND] shutdown error: %s", cepid, itron_strerror(error));

	syscall(slp_tsk());
	}

/*
 *  TCP ECHO 饤ȼ
 */

#ifdef USE_COPYSAVE_API

void
tcp_echo_cli_rcv_task (VP_INT exinf)
{
	ID	tskid;
	int	roff, rlen, total, error;
	UB	*rmsg;
	SYSTIM	time;

	get_tid(&tskid);
	syslog(LOG_NOTICE, "[TCP ECHO CLI (CS) RCV:%d,%d] started.", tskid, (ID)exinf);
	while (TRUE) {
		syscall(slp_tsk());

		roff = rcount = total = 0;
		while (roff < SND_BUF_SIZE * NUM_ECHO) {
			if ((rlen = tcp_rcv_buf((ID)exinf, (VP*)&rmsg, 120 * SYSTIM_HZ)) < 0) {
				syslog(LOG_NOTICE, "[TEC:%02d RCV] recv buf error: %s",
				                   (ID)exinf, itron_strerror(rlen));
				break;
				}
			else if (rlen > 0) {
				roff  += rlen;
				total += rlen;
				rcount ++;
#ifdef SHOW_RCV_RANGE
				syslog(LOG_NOTICE, "[TEC:%02d RCV] recv count: %3d, len: %4d, data: %02x -> %02x",
				                   (ID)exinf, rcount, rlen, *rmsg, *(rmsg + rlen - 1));
#endif	/* of #ifdef SHOW_RCV_RANGE */
				}
			else
				break;
			if ((error = tcp_rel_buf((ID)exinf, rlen)) != E_OK)
				syslog(LOG_NOTICE, "[TEC:%02d RCV] rel buf error: %s", (ID)exinf, itron_strerror(error));
			}

		if ((error = tcp_cls_cep((ID)exinf, TMO_FEVR)) < 0)
			syslog(LOG_NOTICE, "[TEC:%02d RCV] close error: %s", (ID)exinf, itron_strerror(error));

		get_tim(&time);
		syslog(LOG_NOTICE, "[TEC:%02d RCV] finished:   %6d, snd: %4d, rcv: %4d, len: %d",
		                   (ID)exinf, time / SYSTIM_HZ, scount, rcount, total);

		syscall(wup_tsk(TCP_ECHO_CLI_SND_TASK));
		}
	}

#else	/* of #ifdef USE_COPYSAVE_API */

void
tcp_echo_cli_rcv_task (VP_INT exinf)
{
	static UB rmsg[RCV_BUF_SIZE];

	ID	tskid;
	int	roff, rlen, total;
	SYSTIM	time;
	ER	error;

	get_tid(&tskid);
	syslog(LOG_NOTICE, "[TCP ECHO CLI RCV:%d,%d] started.", tskid, (ID)exinf);
	while (TRUE) {
		syscall(slp_tsk());

		roff = rcount = total = 0;
		while (roff < SND_BUF_SIZE * NUM_ECHO) {
			if ((rlen = tcp_rcv_dat((ID)exinf, rmsg, sizeof(rmsg), 120 * SYSTIM_HZ)) < 0) {
				syslog(LOG_NOTICE, "[TEC:%02d RCV] recv error: %s", (ID)exinf, itron_strerror(rlen));
				break;
				}
			else if (rlen > 0) {
				roff  += rlen;
				total += rlen;
				rcount ++;
#ifdef SHOW_RCV_RANGE
				syslog(LOG_NOTICE, "[TEC:%02d RCV] recv count: %3d, len: %4d, data: %02x -> %02x",
				                   (ID)exinf, rcount, rlen, *rmsg, *(rmsg + rlen - 1));
#endif	/* of #ifdef SHOW_RCV_RANGE */
				}
			else
				break;
			}

		if ((error = tcp_cls_cep((ID)exinf, TMO_FEVR)) < 0)
			syslog(LOG_NOTICE, "[TEC:%02d RCV] close error: %s", (ID)exinf, itron_strerror(error));

		get_tim(&time);
		syslog(LOG_NOTICE, "[TEC:%02d RCV] received:   %6d, snd: %4d, rcv: %4d, len: %d",
		                   (ID)exinf, time / SYSTIM_HZ, scount, rcount, total);

		syscall(wup_tsk(TCP_ECHO_CLI_SND_TASK));
		}
	}

#endif	/* of #ifdef USE_COPYSAVE_API */

#endif	/* of #ifdef USE_TCP_NON_BLOCKING */

/*
 *  TCP ECHO 饤
 */

void
tcp_echo_cli_snd_task (VP_INT exinf)
{
	T_IN_ADDR	addr;
	UB		*line;
	UW		count;
	int		no;
	ID		tskid;
	UH		portno;

	get_tid(&tskid);
	syslog(LOG_NOTICE, "[TCP ECHO CLI SND:%d,%d] started.", tskid, (ID)exinf);
	while (TRUE) {
		if (rcv_dtq(DTQ_TCP_ECHO_CLI, (VP_INT*)(VP)&line) == E_OK) {
			line = skip_blanks(GET_IPADDR(&addr, skip_blanks(line)));
			if ('0' < *line && *line < '9') {
				line = get_int(&no, line);
				portno = (UH)no;
				}
			else {
				line ++;
				portno = 7;
				}
			line = skip_blanks(line);
			if (('0' < *line && *line < '9'))
				line = get_int(&no, line);
			else
				no = 1;
			tcp_echo_cli_valid = TRUE;
			for (count = no; count -- > 0; ) {
				if (!tcp_echo_cli_valid) {
					syslog(LOG_NOTICE, "[TEC:%02d SND] canceled.", (ID)exinf);
					break;
					}
				syslog(LOG_NOTICE, "[TEC:%02d SND] start:              repeat: %d/%d", (ID)exinf, no - count, no);
				send_tcp_echo((ID)exinf, &addr, portno);
				syslog(LOG_NOTICE, "[TEC:%02d SND] finished:           repeat: %d/%d", (ID)exinf, no - count, no);
				syscall(dly_tsk(500 + rand() % 2500));
				}
			}
		}
	}
