/*
 *  TOPPERS/JSP Kernel
 *      Toyohashi Open Platform for Embedded Real-Time Systems/
 *      Just Standard Profile Kernel
 * 
 *  Copyright (C) 2000-2004 by Embedded and Real-Time Systems Laboratory
 *                              Toyohashi Univ. of Technology, JAPAN
 *  Copyright (C) 2001-2004 by Dep. of Computer Science and Engineering
 *                   Tomakomai National College of Technology, JAPAN
 *
 *  嵭Ԥϡʲ (1)(4) ξ狼Free Software Foundation 
 *  ˤäƸɽƤ GNU General Public License  Version 2 ˵
 *  ҤƤ˸¤ꡤܥեȥܥեȥ
 *  ѤΤޤࡥʲƱˤѡʣѡۡʰʲ
 *  ѤȸƤ֡ˤ뤳Ȥ̵ǵ롥
 *  (1) ܥեȥ򥽡ɤηѤˤϡ嵭
 *      ɽѾ浪Ӳ̵ݾڵ꤬Τޤޤηǥ
 *      ˴ޤޤƤ뤳ȡ
 *  (2) ܥեȥ򡤥饤֥ʤɡ¾Υեȥȯ˻
 *      ѤǤǺۤˤϡۤȼɥȡ
 *      ԥޥ˥奢ʤɡˤˡ嵭ɽѾ浪Ӳ
 *      ̵ݾڵǺܤ뤳ȡ
 *  (3) ܥեȥ򡤵Ȥ߹ʤɡ¾Υեȥȯ˻
 *      ѤǤʤǺۤˤϡΤ줫ξ
 *      ȡ
 *    (a) ۤȼɥȡѼԥޥ˥奢ʤɡˤˡ嵭
 *        ɽѾ浪Ӳ̵ݾڵǺܤ뤳ȡ
 *    (b) ۤη֤̤ˡˤäơTOPPERSץȤ
 *        𤹤뤳ȡ
 *  (4) ܥեȥѤˤľŪޤϴŪ뤤ʤ»
 *      ⡤嵭ԤTOPPERSץȤդ뤳ȡ
 *
 *  ܥեȥϡ̵ݾڤ󶡤ƤΤǤ롥嵭Ԥ
 *  TOPPERSץȤϡܥեȥ˴ؤơŬѲǽ
 *  ޤơʤݾڤԤʤޤܥեȥѤˤľ
 *  ŪޤϴŪʤ»˴ؤƤ⡤Ǥʤ
 * 
 *  @(#) $Id: tcp_subr.c,v 1.2.1.3 2005/07/25 08:06:42 abe Exp abe $
 */

/*
 * Copyright (c) 1982, 1986, 1988, 1990, 1993, 1995
 *	The Regents of the University of California.  All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in the
 *    documentation and/or other materials provided with the distribution.
 * 3. All advertising materials mentioning features or use of this software
 *    must display the following acknowledgement:
 *	This product includes software developed by the University of
 *	California, Berkeley and its contributors.
 * 4. Neither the name of the University nor the names of its contributors
 *    may be used to endorse or promote products derived from this software
 *    without specific prior written permission.
 *
 * THIS SOFTWARE IS PROVIDED BY THE REGENTS AND CONTRIBUTORS ``AS IS'' AND
 * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
 * ARE DISCLAIMED.  IN NO EVENT SHALL THE REGENTS OR CONTRIBUTORS BE LIABLE
 * FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
 * DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
 * OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
 * HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
 * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
 * OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
 * SUCH DAMAGE.
 *
 *	@(#)tcp_subr.c	8.2 (Berkeley) 5/24/95
 * $FreeBSD: src/sys/netinet/tcp_subr.c,v 1.49.2.4 1999/08/29 16:29:55 peter Exp $
 */

#include <string.h>

#include <s_services.h>
#include <t_services.h>
#include "kernel_id.h"

#include <tinet_defs.h>
#include <tinet_config.h>

#include <net/if.h>
#include <net/if_ppp.h>
#include <net/if_loop.h>
#include <net/ethernet.h>
#include <net/if_arp.h>
#include <net/ppp_ipcp.h>
#include <net/net.h>
#include <net/net_var.h>
#include <net/net_buf.h>
#include <net/net_timer.h>
#include <net/net_count.h>

#include <netinet/in.h>
#include <netinet6/in6.h>
#include <netinet/in_var.h>
#include <netinet/in_itron.h>
#include <netinet/ip.h>
#include <netinet/ip_var.h>
#include <netinet/tcp.h>
#include <netinet/tcp_timer.h>
#include <netinet/tcp_var.h>
#include <netinet/tcp_fsm.h>
#include <netinet/tcp_seq.h>

#include <netinet6/in6_var.h>
#include <netinet6/nd6.h>
#include <netinet/ip6.h>
#include <netinet6/ip6_var.h>

/*
 *  ѿ
 */

/*
 *  TCP  SEQ ν͡ץबươǽ TCP Ȥ
 *  Ȥˡget_tim() ˤ롣
 */
T_TCP_SEQ tcp_iss = 0;

#ifdef SUPPORT_MIB

/*
 *  SNMP  ١ (MIB)
 */

T_TCP_STATS tcp_stats;

#endif	/* of #ifdef SUPPORT_MIB */

/*
 *  ɽѿ
 */

static UH tcp_port_auto = TCP_PORT_FIRST_AUTO;	/* ưֹ	*/

/*
 *  ɽؿ
 */

static void tcp_free_queue (T_TCP_CCEP *cep);

/*
 *  tcp_free_queue -- ȥ塼롣
 */

static void
tcp_free_queue (T_TCP_CCEP *cep)
{
	T_NET_BUF	*q, *nq;

	syscall(wai_sem(cep->semid_lock));
	for (q = cep->segq; q != NULL; q = nq) {
		nq = GET_TCP_Q_HDR(q)->next;
		syscall(rel_net_buf(q));
		}
	cep->segq  = NULL;
	syscall(sig_sem(cep->semid_lock));
	}

/*
 *  tcp_alloc_auto_port -- ưƥݡֹꤹ롣
 */

void
tcp_alloc_auto_port (T_TCP_CCEP *cep)
{
	int	ix;
	UH	portno;

	while (TRUE) {
		portno = tcp_port_auto ++;
		if (tcp_port_auto > TCP_PORT_LAST_AUTO)
			tcp_port_auto = TCP_PORT_FIRST_AUTO;

		for (ix = tmax_tcp_crepid; ix -- > 0; ) {
			if (tcp_crep[ix].myaddr.portno == portno) {
				portno = TCP_PORTANY;
				break;
				}
			}

		if (portno != TCP_PORTANY) {

			syscall(wai_sem(SEM_TCP_CCEP));
			for (ix = tmax_tcp_ccepid; ix -- > 0; ) {
				if (tcp_ccep[ix].myaddr.portno == portno) {
					portno = TCP_PORTANY;
					break;
					}
				}

			if (portno != TCP_PORTANY) {
				cep->myaddr.portno = portno;
				syscall(sig_sem(SEM_TCP_CCEP));
				return;
				}
			syscall(sig_sem(SEM_TCP_CCEP));
			}
		}
	}

/*
 *  tcp_alloc_port -- ꤵ줿ݡֹꤹ롣
 */

ER
tcp_alloc_port (T_TCP_CCEP *cep, UH portno)
{
	int	ix;

	syscall(wai_sem(SEM_TCP_CCEP));
	for (ix = tmax_tcp_ccepid; ix -- > 0; )
		if (tcp_ccep[ix].myaddr.portno == portno) {
			syscall(sig_sem(SEM_TCP_CCEP));
			return E_OBJ;
			}
	cep->myaddr.portno = portno;
	syscall(sig_sem(SEM_TCP_CCEP));
	return E_OK;
	}

/*
 *  tcp_init -- TCP ⥸塼ν
 */

void
tcp_init (void)
{
	timeout(tcp_slow_timo, NULL, TCP_SLOW_TMO);

#ifdef TCP_CFG_DELAY_ACK

	timeout(tcp_fast_timo, NULL, TCP_FAST_TMO);

#endif/* of #ifdef TCP_CFG_DELAY_ACK */
	}

/*
 * tcp_init_iss ֹ롣
 */

void
tcp_init_iss (void)
{
	SYSTIM now;

#ifdef SUPPORT_ETHER

	T_IF_SOFTC	*ic;

	ic = IF_ETHER_NIC_GET_SOFTC();
	syscall(get_tim(&now));
	srand(now + (ic->ifaddr.lladdr[2] << 24)
	          + (ic->ifaddr.lladdr[3] << 16)
	          + (ic->ifaddr.lladdr[4] <<  8)
	          + (ic->ifaddr.lladdr[5]      ));

#else	/* of #ifdef SUPPORT_ETHER */

	syscall(get_tim(&now));
	srand(now);

#endif	/* of #ifdef SUPPORT_ETHER */

	tcp_iss = rand();
	}

/*
 *  tcp_free_all_queue -- Ƥμȥ塼롣
 */

void
tcp_free_all_queue (void)
{
	int ix;

	for (ix = tmax_tcp_ccepid; ix -- > 0; )
		tcp_free_queue(&tcp_ccep[ix]);
	NET_COUNT_TCP(net_count_tcp[NC_TCP_FREE_RCV_QUEUE],   1);
	}

/*
 *  tcp_close -- ͥ롣
 */

T_TCP_CCEP *
tcp_close (T_TCP_CCEP *cep)
{
	/* ޡߤ롣*/
	tcp_cancel_timers(cep);

	/* ȥ塼롣*/
	tcp_free_queue(cep);

	/* ֤̤Ѥˤ롣*/
	cep->fsm_state = TCP_FSM_CLOSED;

	/* ե饰򥯥ꥢ롣*/
	cep->flags = 0;

	if (cep->snd_nblk_tfn != TFN_TCP_UNDEF || cep->rcv_nblk_tfn != TFN_TCP_UNDEF) {
		/* Υ֥å󥰥 */

		if (cep->callback == NULL)
			syslog(LOG_WARNING, "[tcp_close] no call back.");
		else {
			if (cep->rcv_nblk_tfn != TFN_TCP_UNDEF) {

				INT	len, offset;

				switch (cep->rcv_nblk_tfn) {

				case TFN_TCP_ACP_CEP:
					/* ̿üո̿üꥹȤ鳰*/
					cep->rep = NULL;
					(*cep->callback)(GET_TCP_CCEPID(cep), cep->rcv_nblk_tfn, (VP)E_CLS);
					break;

				case TFN_TCP_RCV_BUF:

					/* Хåեå롣*/
					syscall(wai_sem(cep->semid_lock));

					/* ХåեΥǡĹ׻롣*/
					if (cep->rbuf_count > cep->rbufsz - (cep->rbuf_rptr - (UB*)cep->rbuf)) {
						/* ݥ󥿤饦ɤȤϥХåեνޤ */
						len = cep->rbufsz - (cep->rbuf_rptr - (UB*)cep->rbuf);
						}
					else
						len = cep->rbuf_count;

					/* tcp_rcv_buf γĹꤹ롣*/
					cep->rcv_buf_len = len;

					/* ۾Υ顼ꤹ롣*/
					if (cep->error == E_TMOUT)
						len = E_CLS;
					else if (cep->error < 0)
						len = cep->error;

					/* ХåեΥɥ쥹֤*/
					*cep->rcv_p_buf = cep->rbuf_rptr;

					/* ХåեΥå롣*/
					syscall(sig_sem(cep->semid_lock));

					(*cep->callback)(GET_TCP_CCEPID(cep), cep->rcv_nblk_tfn, (VP)len);
					break;

				case TFN_TCP_RCV_DAT:

					/* Хåեå롣*/
					syscall(wai_sem(cep->semid_lock));

					/* cep->rcv_len ȼХåեΥǡξܤǡˤ롣*/
					if (cep->rcv_len > cep->rbuf_count)
						len = cep->rbuf_count;
					else
						len = cep->rcv_len;

					if (len > 0) {

						/* ɤ߽Фݥ󥿤饦ɤȤν */
						if (len > cep->rbufsz - (cep->rbuf_rptr - (UB*)cep->rbuf)) {
							offset = cep->rbufsz - (cep->rbuf_rptr -(UB*)cep->rbuf);
							memcpy(cep->rcv_data, cep->rbuf_rptr, offset);
							cep->rbuf_rptr  = (UB*)cep->rbuf;
							cep->rbuf_count -= offset;
							}
						else
							offset = 0;

						memcpy(cep->rcv_data + offset, cep->rbuf_rptr, len - offset);
						cep->rbuf_rptr  += len - offset;
						cep->rbuf_count -= len - offset;
						}
					else if (cep->error == E_TMOUT)
						len = E_CLS;
					else if (cep->error != E_OK)
						len = cep->error;

					/* ХåեΥå롣*/
					syscall(sig_sem(cep->semid_lock));

					(*cep->callback)(GET_TCP_CCEPID(cep), cep->rcv_nblk_tfn, (VP)len);
					break;

				case TFN_TCP_CLS_CEP:
					/* ̿üո̿üꥹȤ鳰*/
					cep->rep = NULL;
					if (cep->error == E_TMOUT)
						(*cep->callback)(GET_TCP_CCEPID(cep), cep->rcv_nblk_tfn, (VP)E_CLS);
					else
						(*cep->callback)(GET_TCP_CCEPID(cep), cep->rcv_nblk_tfn, (VP)cep->error);
					break;

				default:
					syslog(LOG_WARNING, "[tcp_close] unexp TFN: %s.", in_strtfn(cep->rcv_nblk_tfn));
					break;
					}

				/* Ƥ륿 ID  API ǽɤ򥯥ꥢ롣*/
				cep->rcv_tskid = TA_NULL;
				cep->rcv_tfn   = cep->rcv_nblk_tfn = TFN_TCP_UNDEF;
				}

			if (cep->snd_nblk_tfn != TFN_TCP_UNDEF) {

				switch (cep->snd_nblk_tfn) {

				case TFN_TCP_CON_CEP:
					/* ̿üո̿üꥹȤ鳰*/
					cep->rep = NULL;
					(*cep->callback)(GET_TCP_CCEPID(cep), cep->snd_nblk_tfn, (VP)E_CLS);
					break;

				case TFN_TCP_SND_DAT:
				case TFN_TCP_GET_BUF:
					/* ̿üո̿üꥹȤ鳰*/
					cep->rep = NULL;
					if (cep->error == E_TMOUT)
						(*cep->callback)(GET_TCP_CCEPID(cep), cep->snd_nblk_tfn, (VP)E_CLS);
					else
						(*cep->callback)(GET_TCP_CCEPID(cep), cep->snd_nblk_tfn, (VP)cep->error);
					break;

				default:
					/* ̿üո̿üꥹȤ鳰*/
					cep->rep = NULL;
					syslog(LOG_WARNING, "[tcp_close] unexp TFN: %s.", in_strtfn(cep->snd_nblk_tfn));
					break;
					}

				/* Ƥ륿 ID  API ǽɤ򥯥ꥢ롣*/
				cep->snd_tskid = TA_NULL;
				cep->snd_tfn   = cep->snd_nblk_tfn = TFN_TCP_UNDEF;
				}

			}

		/* ̤ѤˤʤäȤΤ餻롣*/
		syscall(set_flg(cep->flgid, CEP_EVT_CLOSED));
		}
	else {	/* Υ֥å󥰥 */

		/* Ƥ륿 ID  API ǽɤ򥯥ꥢ롣*/
		cep->snd_tskid = cep->rcv_tskid = TA_NULL;
		cep->snd_tfn   = cep->rcv_tfn   = TFN_TCP_UNDEF;

		/* ̤ѤˤʤäȤΤ餻롣*/
		syscall(set_flg(cep->flgid, CEP_EVT_CLOSED));

		/*
		 * ϥ򵯾ơ
		 * ԲĤˤʤäȤΤ餻롣
		 */
		sig_sem(cep->semid_sbuf_ready);
		sig_sem(cep->semid_rbuf_ready);
		}

	return NULL;
	}

/*
 *  tcp_drop -- TCP ³˴롣
 */

T_TCP_CCEP *
tcp_drop (T_TCP_CCEP *cep, ER errno)
{
#ifdef SUPPORT_MIB

	if ((cep->fsm_state == TCP_FSM_SYN_SENT) || (cep->fsm_state == TCP_FSM_SYN_RECVD)) {
		NET_COUNT_MIB(tcp_stats.tcpAttemptFails, 1);
		}

#endif	/* of #ifdef SUPPORT_MIB */

	if (TCP_FSM_HAVE_RCVD_SYN(cep->fsm_state)) {
		cep->fsm_state = TCP_FSM_CLOSED;
		tcp_output(cep, TMO_TCP_OUTPUT);
		}
	cep->error = errno;
	return tcp_close(cep);
	}

/*
 *  tcp_respond -- TCP ñå롣
 */

void
tcp_respond (T_NET_BUF *output, T_TCP_CCEP *cep,
             T_TCP_SEQ ack, T_TCP_SEQ seq, int flags, TMO tmout)
{
	T_IP_HDR	*iph;
	T_TCP_HDR	*tcph;
	SYSTIM		before, after;
	int		win = 0;

	/*
	 *  output  NULL ǤʤСϤȤ
	 *  net_buf ǡΤޤ޺Ѥ롣
	 */
	if (output != NULL) {
		T_IN_ADDR	ipaddr;
		UH		portno;

		if ((flags & TCP_FLG_RST) == 0)
			win = cep->rbufsz - cep->rbuf_count;

		/*
		 * IPv4 ǤϡIP إåΥץ롣
		 * IPv6 Ǥϡĥإå롣
		 */
		if (IP_REMOVE_OPTIONS(output) != E_OK) {
			syscall(rel_net_buf(output));
			return;
			}

		iph  = GET_IP_HDR(output);

		/* IP ɥ쥹򴹤롣*/
		ipaddr = iph->src;
		iph->src = iph->dst;
		iph->dst = ipaddr;

		tcph = GET_TCP_HDR(output);

		/* TCP ץ롣*/
		IP_UPDATE_SDU_LEN(iph, TCP_HDR_LEN(tcph->off) - TCP_HDR_SIZE);

		/* ݡֹ򴹤롣*/
		portno = tcph->sport;
		tcph->sport = tcph->dport;
		tcph->dport = portno;



		/* TCP إå˾ꤹ롣*/
		tcph->off = TCP_MAKE_DATA_OFF(TCP_HDR_SIZE);
		tcph->sum = 0;
		}
	
	/* cep  NULL ǤС⤷ʤǽλ롣*/
	else if (cep == NULL)
		return;
	else {
		/* ȳƤλ֤ tmout 鸺롣*/
		syscall(get_tim(&before));

		if (tcp_get_segment(&output, cep, 0, 0, tmout) != E_OK) {
			return;
			}

		/* ȳƤλ֤ tmout 鸺롣*/
		if (!(tmout == TMO_POL || tmout == TMO_FEVR)) {
			syscall(get_tim(&after));
			if (after - before > tmout) {
				syscall(rel_net_buf(output));
				return;
				}
			tmout -= after - before;
			}

		tcph = GET_TCP_HDR(output);
		flags |= TCP_FLG_ACK;
		}

	tcph->seq   = htonl(seq);
	tcph->ack   = htonl(ack);
	tcph->win   = htonl(win);
	tcph->flags = flags;
	tcph->urp   = 0;

	/*
	 *  åꤹ롣
	 */
	tcph->sum = IN_CKSUM(output, IPPROTO_TCP, GET_TCP_HDR_OFFSET(output),
	                                          GET_TCP_HDR_SIZE(output));

	/* ͥåȥХåեĹĴ롣*/
	output->len = GET_IF_IP_TCP_HDR_SIZE(output);

	/* ͥåȥ (IP) νϴؿƤӽФ*/
	IP_OUTPUT(output, tmout);
	}

/*
 *  tcp_get_segment -- TCP Ȥإåꤹ롣
 *
 *    	顼
 *    optlen	ץ󥵥4 ƥåñ
 *    len	TCP SDU 
 */

ER
tcp_get_segment (T_NET_BUF **nbuf, T_TCP_CCEP *cep, int optlen, int len, TMO tmout)
{
	T_TCP_HDR	*tcph;
	ER		error;

	/* IP ǡ롣*/
	if ((error = IN_GET_DATAGRAM(nbuf,
	                             TCP_HDR_SIZE + optlen + len,
	                             &cep->dstaddr.ipaddr,
	                             &cep->myaddr.ipaddr,
	                             IPPROTO_TCP, IP_DEFTTL, tmout)) != E_OK) {
		syslog(LOG_WARNING, "[TCP] net_buf busy, len=%d", TCP_HDR_SIZE + optlen + len);
		tcp_free_all_queue();
		return error;
		}

	/* TCP إå˾ꤹ롣*/
	tcph		= GET_TCP_HDR(*nbuf);
	tcph->sport	= htons(cep->myaddr.portno);
	tcph->dport	= htons(cep->dstaddr.portno);
	tcph->off	= TCP_MAKE_DATA_OFF(TCP_HDR_SIZE + optlen);
	tcph->sum	= tcph->flags = 0;

	return E_OK;
	}

/*
 *  tcp_sbuf_drop -- Хåեꤵ줿ƥåʬ롣
 */

void
tcp_sbuf_drop (T_TCP_CCEP *cep, int len)
{
	UH	last;

	/* Хåեå롣*/
	syscall(wai_sem(cep->semid_lock));

	last = cep->sbuf_count;

	if (cep->sbuf_rptr + len > (UB*)cep->sbuf + cep->sbufsz)
		/* 饦ɤȤη׻ */
		cep->sbuf_rptr -= cep->sbufsz - len;
	else
		cep->sbuf_rptr += len;
	cep->sbuf_count -= (UH)len;

	if (cep->snd_nblk_tfn == TFN_TCP_GET_BUF) {	/* Υ֥å󥰥 */

		/* ХåեĹ׻롣*/
		if (cep->sbufsz - cep->sbuf_count > cep->sbufsz - (cep->sbuf_wptr - (UB*)cep->sbuf))
			/* ߥݥ󥿤饦ɤȤϡߥݥ󥿤Хåեνޤ */
			len = cep->sbufsz - (cep->sbuf_wptr - (UB*)cep->sbuf);
		else
			len = cep->sbufsz - cep->sbuf_count;

		/* ХåեΥå롣*/
		syscall(sig_sem(cep->semid_lock));

		if (len > 0) {

			/* tcp_get_buf γĹꤹ롣*/
			cep->get_buf_len = len;

			/* ХåեΥɥ쥹֤*/
			*cep->snd_p_buf = cep->sbuf_wptr;

			if (cep->callback == NULL)
				syslog(LOG_WARNING, "[tcp_sbuf_drop] no call back.");
			else
				(*cep->callback)(GET_TCP_CCEPID(cep), cep->snd_nblk_tfn, (VP)len);

			/* Ƥ륿 ID  API ǽɤ򥯥ꥢ롣*/
			cep->snd_tskid = TA_NULL;
			cep->snd_tfn   = cep->snd_nblk_tfn = TFN_TCP_UNDEF;
			}
		}

	else if (cep->snd_nblk_tfn == TFN_TCP_SND_DAT) {	/* Υ֥å󥰥 */

		INT	offset;

		/* cep->snd_len Хåեζξܤǡˤ롣*/
		if (cep->snd_len > (cep->sbufsz - cep->sbuf_count))
			len = cep->sbufsz - cep->sbuf_count;
		else
			len = cep->snd_len;

		if (len > 0) {

			/* 񤭹ߥݥ󥿤饦ɤȤν */
			if (len > cep->sbufsz - (cep->sbuf_wptr - (UB*)cep->sbuf)) {
				offset = cep->sbufsz - (cep->sbuf_wptr -(UB*)cep->sbuf);
				memcpy(cep->sbuf_wptr, cep->snd_data, offset);
				cep->sbuf_wptr  = (UB*)cep->sbuf;
				cep->sbuf_count += offset;
				}
			else
				offset = 0;

			memcpy(cep->sbuf_wptr, cep->snd_data + offset, len - offset);
			cep->sbuf_wptr  += len - offset;
			cep->sbuf_count += len - offset;

			/* CEP Υå롣*/
			syscall(sig_sem(cep->semid_lock));

			if (cep->callback == NULL)
				syslog(LOG_WARNING, "[tcp_snd_dat] no call back.");
			else
				(*cep->callback)(GET_TCP_CCEPID(cep), cep->snd_nblk_tfn, (VP)len);

			/* Ƥ륿 ID  API ǽɤ򥯥ꥢ롣*/
			cep->snd_tskid = TA_NULL;
			cep->snd_tfn   = cep->snd_nblk_tfn = TFN_TCP_UNDEF;
			}
		else {
			/* ХåեΥå롣*/
			syscall(sig_sem(cep->semid_lock));
			}
		}
	else {

		/* ХåեΥå롣*/
		syscall(sig_sem(cep->semid_lock));

		/* Хåե˶褿ϥ򵯾롣*/
		if (last == cep->sbufsz && cep->sbuf_count < cep->sbufsz)
			sig_sem(cep->semid_sbuf_ready);
		}

	if (cep->sbuf_count > 0) {
		/* Хåե˥ǡнϤݥȤ롣*/
		cep->flags |= CEP_FLG_POST_OUTPUT;
		sig_sem(SEM_TCP_POST_OUTPUT);
		}
	}

/*
 *  tcp_rbuf_append -- Хåե˥ǡɲä롣
 *
 *    :
 *	 input ϡT_TCP_Q_HDR ˤ󥯤졢
 *	¤ؤλƤʤФʤʤޤ
 *	ɲäǡϡХåե˼ޤ뤳ȡ
 */

void
tcp_rbuf_append (T_TCP_CCEP *cep, T_NET_BUF *input)
{
	int		offset, inlen;
	UH		last;

	/* Хåեå롣*/
	syscall(wai_sem(cep->semid_lock));

	last = cep->rbuf_count;
	inlen = ((T_TCP_Q_HDR*)GET_TCP_HDR(input))->len;

	/*
	 *  FIN ե饰դȤ inlen == 0 ˤʤ뤳Ȥ⤢롣
	 *  ϡץꥱˡ꤫餳ʾǡ
	 *  ʤȤΤ餻뤿Ǥ롣
	 */
	if (inlen > 0) {

		/* 񤭹ߥݥ󥿤饦ɤȤν */
		if (inlen > cep->rbufsz - (cep->rbuf_wptr - (UB*)cep->rbuf)) {
			offset = cep->rbufsz - (cep->rbuf_wptr - (UB*)cep->rbuf);
			memcpy(cep->rbuf_wptr, (VP)GET_TCP_SDU(input), offset);
			cep->rbuf_wptr   = (UB*)cep->rbuf;
			cep->rbuf_count += offset;
			inlen           -= offset;
			}
		else
			offset	= 0;

		memcpy(cep->rbuf_wptr, (VP)(GET_TCP_SDU(input) + offset), inlen);
		cep->rbuf_wptr  += inlen;
		cep->rbuf_count += inlen;

		NET_COUNT_TCP(net_count_tcp[NC_TCP_RECV_DATA_SEGS],   1);
		NET_COUNT_TCP(net_count_tcp[NC_TCP_RECV_DATA_OCTETS], inlen);
		}

	syscall(rel_net_buf(input));

	if (cep->rcv_nblk_tfn == TFN_TCP_RCV_BUF) {	/* Υ֥å󥰥 */

		INT	len;

		/* ХåեΥǡĹ׻롣*/
		if (cep->rbuf_count > cep->rbufsz - (cep->rbuf_rptr - (UB*)cep->rbuf)) {
			/* ݥ󥿤饦ɤȤϥХåեνޤ */
			len = cep->rbufsz - (cep->rbuf_rptr - (UB*)cep->rbuf);
			}
		else
			len = cep->rbuf_count;

		/* ХåեΥå롣*/
		syscall(sig_sem(cep->semid_lock));

		/*
		 *  FIN ե饰դȤ inlen == 0 ˤʤ뤳Ȥ⤢롣
		 *  ϡץꥱˡ꤫餳ʾǡ
		 *  ʤȤΤ餻뤿Ǥ롣
		 */
		if (len > 0 || inlen == 0) {

			/* tcp_rcv_buf γĹꤹ롣*/
			cep->rcv_buf_len = len;

			/* ХåեΥɥ쥹֤*/
			*cep->rcv_p_buf = cep->rbuf_rptr;

			if (cep->callback == NULL)
				syslog(LOG_WARNING, "[tcp_rbuf_append] no call back.");
			else
				(*cep->callback)(GET_TCP_CCEPID(cep), cep->rcv_nblk_tfn, (VP)len);

			/* Ƥ륿 ID  API ǽɤ򥯥ꥢ롣*/
			cep->rcv_tskid = TA_NULL;
			cep->rcv_tfn   = cep->rcv_nblk_tfn = TFN_TCP_UNDEF;
			}
		}

	else if (cep->rcv_nblk_tfn == TFN_TCP_RCV_DAT) {	/* Υ֥å󥰥 */
		INT	len;

		/* cep->rcv_len ȼХåեΥǡξܤǡˤ롣*/
		if (cep->rcv_len > cep->rbuf_count)
			len = cep->rbuf_count;
		else
			len = cep->rcv_len;

		/*
		 *  FIN ե饰դȤ inlen == 0 ˤʤ뤳Ȥ⤢롣
		 *  ϡץꥱˡ꤫餳ʾǡ
		 *  ʤȤΤ餻뤿Ǥ롣
		 */
		if (len > 0 || inlen == 0) {

			if (len > 0) {
				/* ɤ߽Фݥ󥿤饦ɤȤν */
				if (len > cep->rbufsz - (cep->rbuf_rptr - (UB*)cep->rbuf)) {
					offset = cep->rbufsz - (cep->rbuf_rptr -(UB*)cep->rbuf);
					memcpy(cep->rcv_data, cep->rbuf_rptr, offset);
					cep->rbuf_rptr  = (UB*)cep->rbuf;
					cep->rbuf_count -= offset;
					}
				else
					offset = 0;

				memcpy(cep->rcv_data + offset, cep->rbuf_rptr, len - offset);
				cep->rbuf_rptr  += len - offset;
				cep->rbuf_count -= len - offset;

				/* ˥ɥѤäȤΤ餻뤿ϤݥȤ롣*/
				cep->flags |= CEP_FLG_POST_OUTPUT;
				sig_sem(SEM_TCP_POST_OUTPUT);
				}

			/* CEP Υå롣*/
			syscall(sig_sem(cep->semid_lock));

			if (cep->callback == NULL)
				syslog(LOG_WARNING, "[tcp_rbuf_append] no call back.");
			else
				(*cep->callback)(GET_TCP_CCEPID(cep), cep->rcv_nblk_tfn, (VP)len);

			/* Ƥ륿 ID  API ǽɤ򥯥ꥢ롣*/
			cep->rcv_tskid = TA_NULL;
			cep->rcv_tfn   = cep->rcv_nblk_tfn = TFN_TCP_UNDEF;
			}
		else {
			/* ХåեΥå롣*/
			syscall(sig_sem(cep->semid_lock));
			}
		}
	else {
		/* ХåեΥå롣*/
		syscall(sig_sem(cep->semid_lock));

		/*
		 *  Хåե˥ǡ뤫 inlen == 0 λϥ򵯾롣
		 *  FIN ե饰դȤ inlen == 0 ˤʤ뤳Ȥ⤢롣
		 *  ϡץꥱˡ꤫餳ʾǡ
		 *  ʤȤΤ餻뤿Ǥ롣
		 */
		if ((last == 0 && cep->rbuf_count > 0) || inlen == 0) {
			sig_sem(cep->semid_rbuf_ready);
			}
		}
	}

/*
 *  tcp_seg_fill -- Ȥ˥ǡͤ롣
 */

void
tcp_seg_fill (T_TCP_CCEP *cep, T_NET_BUF *output, int len, int off)
{
	UB	*wptr, *rptr;

	/* SDU 礭å롣*/
	if (GET_IP_SDU_SIZE(GET_IP_HDR(output)) < GET_TCP_HDR_SIZE(output) + len) {
		syslog(LOG_INFO, "[TCP] shrink SUD len: %d -> %d",
		       len, GET_IP_SDU_SIZE(GET_IP_HDR(output)) - GET_TCP_HDR_SIZE(output));
		len = GET_IP_SDU_SIZE(GET_IP_HDR(output)) - GET_TCP_HDR_SIZE(output);
		}

	wptr = GET_TCP_SDU(output);

	/* Хåեå롣*/
	syscall(wai_sem(cep->semid_lock));

	rptr = cep->sbuf_rptr + off;
	if (rptr - (UB*)cep->sbuf > cep->sbufsz) {

		/* žϤХåեνĶȤν*/
		rptr = (UB*)cep->sbuf_rptr - (cep->sbufsz - off);
		}
	else if (len + (rptr - (UB*)cep->sbuf) > cep->sbufsz) {
		int sub;

		/* žϰϤ饦ɤȤν */
		sub = cep->sbufsz - (rptr - (UB*)cep->sbuf);
		memcpy((VP)wptr, rptr, sub);
		len  -= sub;
		wptr += sub;
		rptr  = (UB*)cep->sbuf;
		}
	memcpy((VP)wptr, rptr, len);

	NET_COUNT_TCP(net_count_tcp[NC_TCP_SEND_DATA_SEGS],   1);
	NET_COUNT_TCP(net_count_tcp[NC_TCP_SEND_DATA_OCTETS], len);

	/* ХåեΥå롣*/
	syscall(sig_sem(cep->semid_lock));
	}

/*
 *  tcp_rexmt_val -- ॢ֤ͤ
 */

T_TCP_TIME
tcp_rexmt_val (T_TCP_CCEP *cep)
{
	T_TCP_TIME val;

	val = ((cep->srtt >> (TCP_SRTT_SHIFT - TCP_DELTA_SHIFT)) + cep->rttvar) >> TCP_DELTA_SHIFT;
	if (cep->rttmin > val)
		return cep->rttmin;
	else
		return val;
	}

/*
 *  tcp_init_cep -- ̿ü롣
 */

#define tcp_offsetof(structure, field) ((INT) &(((structure *) 0)->field))

void
tcp_init_cep (T_TCP_CCEP *cep)
{
	memset((VP)((UB*)cep + tcp_offsetof(T_TCP_CCEP, timer)), 0,
	       sizeof(T_TCP_CCEP) - tcp_offsetof(T_TCP_CCEP, timer));

	cep->sbuf_rptr	= cep->sbuf_wptr = cep->sbuf;
	cep->rbuf_rptr	= cep->rbuf_wptr = cep->rbuf;

	cep->maxseg	= DEF_TCP_SND_SEG;		/* 祻ȥ		*/
	cep->srtt	= TCP_TVAL_SRTT_BASE;		/* 餫ʰưʿ			*/
	cep->rttvar	= ((TCP_TVAL_RTO_BASE - TCP_TVAL_SRTT_BASE) << TCP_RTTVAR_SHIFT) / 4;
							/* 餫ʬ				*/
	cep->rttmin	= TCP_TVAL_MIN;			/* rtt ˵Ǿ			*/
	cep->rxtcur	= TCP_TVAL_RTO_BASE;		/* ߤκ				*/
	cep->snd_cwnd	=  MAX_TCP_WIN_SIZE;		/* ԥɥ			*/
	cep->snd_ssthresh= MAX_TCP_WIN_SIZE;		/* ԥɥ(snd_cwnd)		*/

	/* ޥե롣*/
	sig_sem (cep->semid_lock);
	sig_sem (cep->semid_sbuf_ready);
	twai_sem(cep->semid_rbuf_ready, TMO_POL);
	}

#undef tcp_offsetof

/*
 *  tcp_notify -- ICMP 顼ν
 */

void
tcp_notify (T_NET_BUF *input, ER error)
{
	T_IP_HDR	*iph;
	T_TCP_HDR	*tcph;
	T_TCP_CCEP	*cep;

	iph  = GET_IP_HDR(input);
	tcph = GET_TCP_HDR(input);

	if ((cep = tcp_find_cep(&iph->src, tcph->sport, &iph->dst, tcph->dport)) != NULL) {

		/*
		 *  ͥߺѤǡۥãǽ顼ξϡ
		 *  ˤ롣
		 */
		if (cep->fsm_state == TCP_FSM_ESTABLISHED &&
		    (error == EV_NURCH || error == EV_HURCH || error == EV_HDOWN))
			return;

		/*
		 *  ͥ桢Ʊ顼٤ϡ
		 *  Ԥ֤бؿ˥顼֤롣
		 */
		if (cep->fsm_state < TCP_FSM_ESTABLISHED && cep->rxtshift > 3 && cep->net_error != E_OK) {
			cep->error = E_CLS;
			tcp_close(cep);
			}
		else {
			cep->net_error = error;
			tcp_output(cep, TMO_TCP_OUTPUT);
			}
		}
	}

/*
 *  tcp_find_cep -- ݡֹ椫 TCP ̿ü롣
 *
 *    : dstaddr ϡ
 *          TINET-1.2 ͥåȥХȥ
 *          TINET-1.1 ޤǤϡۥȥХȥ
 */

T_TCP_CCEP*
tcp_find_cep (T_IN_ADDR *dstaddr, UH dstport, T_IN_ADDR *peeraddr, UH peerport)
{
	T_TCP_CCEP*	cep;
	
	/*
	 *  ֤ SYN Ѥ߰ʸϡ
	 *  IP ɥ쥹ȥݡֹ椬פ̿üõ롣
	 */
	for (cep = &tcp_ccep[tmax_tcp_ccepid]; cep -- != tcp_ccep; ) {
		if (cep->fsm_state >= TCP_FSM_SYN_SENT                    &&
		    IN_IS_DSTADDR_ACCEPT (&cep->myaddr.ipaddr,  dstaddr)  &&
		    IN_ARE_NET_ADDR_EQUAL(&cep->dstaddr.ipaddr, peeraddr) &&
		    dstport  == cep->myaddr.portno                        &&
		    peerport == cep->dstaddr.portno)
			return cep;
		}

	/* ưץ̿üõ롣*/	
	for (cep = &tcp_ccep[tmax_tcp_ccepid]; cep -- != tcp_ccep; ) {
		if (cep->fsm_state == TCP_FSM_LISTEN &&
		    IN_IS_DSTADDR_ACCEPT(&cep->myaddr.ipaddr, dstaddr) &&
		    dstport == cep->myaddr.portno)
			return cep;
		}

	return NULL;
	}
